<?php

App::uses('User', 'EvCore.Model');

class Customer extends User {

	public $useTable = 'users';

	const CUSTOMER_USER_GROUP=3;

	public function validateRegister() {

		$rules = $this->validate;

		$rules['accept_terms'] = array(
			'rule' => array('equalTo', '1'), 
			'message' => 'Please read and accept the Terms & Conditions'
		);

		$rules['confirm_password']['required']['message'] = 'Please confirm password';

		unset($rules['user_group_id']);

		return $rules;

	}


/**
 * Handles user registration 
 * @param  array $userData 	The array of new user data
 * @return int         		New User Id if success else returns false
 */
	public function register($userData) {

		$userData[$this->alias]['user_group_id'] = self::CUSTOMER_USER_GROUP;
		$userData[$this->alias]['is_active'] = 1;

		$this->validate = $this->validateRegister();

		$this->set($userData);

		if($this->save()) {

			return $this->id; 

		} else {

			return false; 

		}

	}

/**
 * Gets the user and all associated data out that is needed for login
 * @param  int $id  The ID of the user
 * @return array 	User array
 */
	public function getUserForLogin($id) {

		$fullUser = $this->find('first', array(
				'conditions' => array(
					$this->alias.'.id' => $id
				),
				'contain'=> array(
					'UserGroup'
				)
			)
		);

		//Swap out Customer for User
		$fullUser['User'] = $fullUser['Customer'];
		unset($fullUser['Customer']);

		return $fullUser; 

	}

}